/*********************************************************************************
 * PROJECT: MiMic
 * --------------------------------------------------------------------------------
 *
 * This file is part of MiMic
 * Copyright (C)2011 Ryo Iizuka
 *
 * MiMic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by　the Free Software Foundation, either version 3 of the　License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * For further information please contact.
 *	http://nyatla.jp/
 *	<airmail(at)ebony.plala.or.jp> or <nyatla(at)nyatla.jp>
 *
 *********************************************************************************/
#include "NyLPC_cSyncCall.h"


/**
 * コンストラクタです。
 */
NyLPC_TBool NyLPC_cSyncCall_initialize(NyLPC_TcSyncCall_t* i_inst)
{
	i_inst->_q=xQueueCreate(1,0);
	NyLPC_Assert(i_inst->_q!=NULL);
	i_inst->_last_proc=NULL;
	return NyLPC_TBool_TRUE;
}


/**
 * i_toへi_msgをポストします。i_msgは、スレッドセーフな割り当てをして下さい。
 * @return
 * true/false 指定時間内にポストが成功するとtrueです。
 */
NyLPC_TBool NyLPC_cSyncCall_call(NyLPC_TcSyncCall_t* i_inst,NyLPC_TcSyncProc_t* i_to,void* i_msg,NyLPC_TUInt32 i_wait_msec)
{
	void* param[2];
	param[0]=i_inst;
	param[1]=i_msg;
	void** ptr=&param[0];
	if(xQueueSend(i_to->_q,&ptr,i_wait_msec/portTICK_RATE_MS)==pdPASS){
		//解除待ち
		NyLPC_AbortIfNot(pdPASS==xQueueReceive(i_inst->_q,NULL,portMAX_DELAY));
		return NyLPC_TBool_TRUE;
	}
	return NyLPC_TBool_FALSE;
}
