/*********************************************************************************
 * PROJECT: MiMic
 * --------------------------------------------------------------------------------
 *
 * This file is part of MiMic
 * Copyright (C)2011 Ryo Iizuka
 *
 * MiMic is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by　the Free Software Foundation, either version 3 of the　License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * For further information please contact.
 *	http://nyatla.jp/
 *	<airmail(at)ebony.plala.or.jp> or <nyatla(at)nyatla.jp>
 *
 *********************************************************************************/
#ifndef NYLPC_CTCPLISTENER_H_
#define NYLPC_CTCPLISTENER_H_

typedef struct NyLPC_TcTcpListener NyLPC_TcTcpListener_t;


#include "../include/NyLPC_stdlib.h"
#include "NyLPC_cTcpSocket.h"
#include "NyLPC_stdlib.h"
/**********************************************************************
 *
 * NyLPC_TcTcpListener class
 *
 **********************************************************************/


/**
 * TCP listenerクラス型です。
 */
struct NyLPC_TcTcpListener
{
	NyLPC_TInt16 _port;				/**<ネットワークオーダーのポート番号*/
	/** バインドするためのソケット*/
	NyLPC_TcTcpSocket_t* _ref_sock;
	/** タスク間の調停用Mutex*/
	NyLPC_TcMutex_t _mutex;
};
/**
 * この関数は、TCPのリスナーを初期化します。
 * 初期化したリスナーをサービスに登録することにより、listen関数を使用できるようになります。
 * サービスへの登録は、NyLPC_cUipService_addListenerを使います。
 */
NyLPC_TBool NyLPC_cTcpListener_initialize(NyLPC_TcTcpListener_t* i_inst,NyLPC_TUInt16 i_port);

NyLPC_TBool NyLPC_cTcpListener_listen(NyLPC_TcTcpListener_t* i_inst,NyLPC_TcTcpSocket_t* i_sock,NyLPC_TUInt32 i_wait_msec);




#endif /* NYLPC_CTCPLISTENER_H_ */
